<script lang="ts">
    import Server from '../components/server.svelte';
    import useCases from '../app/use-cases';
    import { ServerModel } from '../app/domain/models/server.model';
    import { onMount } from 'svelte';

    let loading: boolean = true;
    let servers: ServerModel[] = [];
    let activeServer: ServerModel;
    let newServerAdapter: string = 'adminer';

    function Bootstrap() {
        servers = useCases.fetchServersUc.execute();
        const activeServerId = useCases.getActiveServerUc.execute();
        activeServer = servers.find(s => s.id === activeServerId);
        save();
    }
    Bootstrap();

    onMount(() => {
        loading = false;
    });

    function createConfig() {
        const server = useCases.createServerUc.execute(newServerAdapter);
        useCases.setActiveServerUc.execute(server);
        activeServer = server;
        servers = [...servers, activeServer];
        save();
    }

    function selectServer(server: ServerModel | undefined) {
        activeServer = server;
        useCases.setActiveServerUc.execute(activeServer);
        save();
    }

    function deleteServer(server: ServerModel) {
        activeServer = undefined;
        servers = servers.filter(s => s !== server);
        useCases.setActiveServerUc.execute(activeServer);
        save();
    }

    function save() {
        useCases.persistUc.execute(servers);
    }

</script>

<div class="container">
    <div class="tabs is-boxed">
        <ul>
            {#each servers as server}
                {#if server === activeServer}
                    <li class="is-active">
                        <a>
                            <span>{activeServer.name}</span>
                            <span class="icon" on:click={() => deleteServer(server)}><i class="fas fa-close" aria-hidden="true"></i></span>
                        </a>
                    </li>
                {:else}
                    <li>
                        <a>
                            <span on:click={() => selectServer(server)}>{server.name}</span>
                            <span class="icon" on:click={() => deleteServer(server)}><i class="fas fa-close" aria-hidden="true"></i></span>
                        </a>
                    </li>
                {/if}
            {/each}
            <li class:is-active={!activeServer} on:click={() => selectServer(undefined)}><a>+</a></li>
        </ul>
    </div>

    {#if (activeServer)}
        <Server bind:server={activeServer} on:save={save}></Server>
    {:else}
        <form>
            <div class="field is-horizontal">
                <div class="field-label is-normal">
                    <label class="label">Adapter</label>
                </div>
                <div class="field-body">
                    <div class="field is-narrow">
                        <div class="control">
                            <div class="select is-fullwidth">
                                <select bind:value={newServerAdapter}>
                                    <option value="adminer">Adminer</option>
                                    <option value="phpmyadmin511">PhpMyAdmin511</option>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="field is-horizontal">
                <div class="field-label">
                    <!-- Left empty for spacing -->
                </div>
                <div class="field-body">
                    <div class="field">
                        <div class="control">
                            <button type="button" class="button is-primary" on:click={createConfig}>
                                Create
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    {/if}
</div>

<div class="modal" class:is-active={loading}>
    <div class="modal-background"></div>
    <div class="modal-content">
        <div class="has-text-centered box">
            <p>Please wait</p>
            <button class="button is-primary is-loading">Loading</button>
        </div>
    </div>
</div>
